package com.ynet.life.sujrb.controller;

import com.ynet.gene.core.Context;
import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.core.GENEException;
import com.ynet.gene.flow.GENEFlow;
import com.ynet.gene.log.GENELog;
import com.ynet.gene.session.GENESession;
import com.ynet.gene.session.InvalidSessionException;
import com.ynet.gene.session.Session;
import com.ynet.gene.session.SessionManager;
import com.ynet.gene.transaction.GENETransactionManager;
import com.ynet.gene.web.servlet.ModelAndView;
import com.ynet.gene.web.servlet.mvc.BizLogicException;
import com.ynet.gene.web.servlet.mvc.GENEFlowExecuteResult;
import com.ynet.gene.web.servlet.mvc.GENESessionRequestController;
import com.ynet.gene.web.servlet.mvc.InvalidInputException;
import com.ynet.gene.web.servlet.view.View;
import com.ynet.life.base.LifePlatManager;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.MVCEntity;
import com.ynet.life.base.TEntity;
import com.ynet.life.base.Trace;
import com.ynet.life.base.logon.LifeCacheLogonManager;
import com.ynet.life.base.logon.LifeLogonManager;
import com.ynet.life.controller.LifeClientRequest;
import com.ynet.life.exception.TranFailException;
import com.ynet.life.mvc.MVCXmlView;
import com.ynet.life.mvc.XMLView;
import com.ynet.life.platform.util.PlatformUtil;
import java.net.InetAddress;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import javax.servlet.http.Cookie;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.collections.LRUMap;
import org.apache.commons.lang.StringUtils;
import org.w3c.dom.Document;

/* loaded from: com_ynet_life_sujrb_controller.jar:com/ynet/life/sujrb/controller/PBPAYEstablishSessionController.class */
public class PBPAYEstablishSessionController extends GENESessionRequestController {
    private static boolean isServerAddressInitialized = false;
    private static final String isStrengthVerify = "singleSign";
    private String sessionContextName;
    protected String sessionIdFieldName = "sessionId";
    private boolean isSingleLogonCheck = true;

    public ModelAndView doRequest(HttpServletRequest request, HttpServletResponse response) throws Exception {
        ModelAndView result;
        initServerAddress(request);
        if (this.openMonitor) {
            this.accessInfo.newAccess();
        }
        SessionManager method = request.getMethod();
        try {
            if (this.flowDef == null) {
                Map model = new HashMap();
                new ModelAndView(model, getView());
            }
            if (getView() != null && !"POST".equalsIgnoreCase(method)) {
                Map model2 = new HashMap();
                result = new ModelAndView(model2, getView());
            } else {
                result = executeTheFlow(request, response);
            }
            if (((Exception) result.getModel().get(GENEConstance.ATTR_EXCEPTION)) == null) {
                Context context = (Context) result.getModel().get(GENEConstance.ATTR_CONTEXT);
                String sessionId = (String) context.getDataValue(TEntity.appKeyFieldname);
                Session userSession = (Session) this.sessionManager.getSessions().get(sessionId);
                String clientIp = LifeClientRequest.getClientIP(request);
                String str = PlatformUtil.getBankId4LinkLAN(request);
                StringBuffer clientInfoBuf = new StringBuffer();
                clientInfoBuf.append(clientIp).append(str);
                String clientInfo = clientInfoBuf.toString();
                String bankId = (String) context.getDataValue(TEntity.bankIdFieldName);
                String channel = (String) context.getDataValue(TEntity.channelFieldname);
                context.getDataValue(TEntity.customerIdFieldname);
                context.getDataValue(TEntity.mobileNo);
                String serverAddress = LifeStandard.getSelfDefineSettingsValue("serverAddress");
                MVCEntity mvcEntity = new MVCEntity();
                mvcEntity.setBankId(bankId);
                mvcEntity.setSessionId(sessionId);
                mvcEntity.setClientInfo(clientInfo);
                mvcEntity.setClientIp(clientIp);
                mvcEntity.setChannel(channel);
                mvcEntity.setServerAddress(serverAddress);
                mvcEntity.setReqAppFlag(TEntity.REQ_APP_JRB);
                String cacheServiceFlag = LifeStandard.getSelfDefineSettingsValue("cacheServiceFlag");
                if ("true".equals(cacheServiceFlag)) {
                    LifeStandard.getCache("sessionData_cache").put(sessionId, mvcEntity);
                } else {
                    userSession.setAttribute(sessionId, mvcEntity);
                    if (context.containsKey(TEntity.MODIFY_CACHE_OR_SESSION_FALG)) {
                        String flag = (String) context.getDataValue(TEntity.MODIFY_CACHE_OR_SESSION_FALG);
                        if ("true".equals(flag)) {
                            Map bsnDataMap = (Map) context.getDataValue(TEntity.BSN_DATA_MAP);
                            userSession.setAttribute(TEntity.BSN_DATA_MAP, bsnDataMap);
                        }
                    }
                    this.sessionManager.cacheSession(userSession);
                }
                setSessionTimeout(userSession, context);
                Map<String, String> flowMap = Collections.synchronizedMap(new LRUMap(10));
                context.put("windowsID_map", flowMap);
                if (context.containsKey(isStrengthVerify)) {
                    String signFlag = (String) context.getDataValue(isStrengthVerify);
                    if ("isSign".equals(signFlag)) {
                        method = this.sessionManager;
                        method.removeSession((String) context.getDataValue(this.sessionIdFieldName));
                    }
                }
            }
            return result;
        } catch (Exception e) {
            throw method;
        }
    }

    protected ModelAndView executeTheFlow(HttpServletRequest request, HttpServletResponse response) throws Exception {
        Context sessionContext = null;
        Session session = initSession(request, response);
        String sessionId = session.getId();
        if (session != null) {
            sessionContext = (Context) session.getAttribute(GENEConstance.ATTR_CONTEXT);
        }
        Map model = new HashMap();
        if (this.flowDef == null) {
            View retView = this.inputView;
            if (this.outputViews != null && this.outputViews.size() > 0) {
                View view = (View) this.outputViews.get("default");
                retView = view;
                if (view == null) {
                    retView = (View) this.outputViews.get("output");
                }
                if (retView == null) {
                    retView = (View) this.outputViews.entrySet().toArray()[0];
                }
            }
            if (retView == null) {
                throw new GENEException("required to execute flow, but no flow defined, and no input/out view defined! " + toString());
            }
            return new ModelAndView(model, retView);
        }
        GENEFlowExecuteResult result = executeGENELogicBizFlow(request, response, sessionId);
        result.context.put(TEntity.appKeyFieldname, (String) sessionContext.getDataValue(this.sessionIdFieldName));
        model.put(GENEConstance.ATTR_CONTEXT, result.context);
        Context context = result.context;
        model.put(GENEConstance.ATTR_FLOW_OUTPUT, result.flow.getOutput(this.flowDef.getOpId()));
        if (result.e != null) {
            if (result.e instanceof InvalidInputException) {
                result.e.setModel(model);
                throw result.e;
            }
            if (result.e instanceof InvalidSessionException) {
                this.sessionManager.removeSession(session);
                throw new BizLogicException(model, result.e);
            }
            throw new BizLogicException(model, result.e);
        }
        return new ModelAndView(model, new XMLView());
    }

    protected GENEFlowExecuteResult executeGENELogicBizFlow(HttpServletRequest request, HttpServletResponse response, String sessionId) {
        String bizId = this.flowDef.getFlowId();
        String opId = this.flowDef.getOpId();
        GENEFlowExecuteResult result = new GENEFlowExecuteResult();
        GENETransactionManager transactionManager = null;
        GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "begin to execute flow " + bizId + " ...");
        try {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Get flow " + bizId + "  from factory...");
            GENEFlow flow = this.geneFactory.getGENEFlow(bizId);
            result.flow = flow;
            Context context = (Context) flow.getContext().clone();
            result.context = putElementToContext(request, context, sessionId);
            transactionManager = (GENETransactionManager) context.getService(GENEConstance.TRX_SVC_NAME);
            GENELog.log(GENEConstance.GENE_MVC, GENELog.DEBUG, 0, "Update the request data ...");
            doUpdateModel(request, context, flow, opId);
            doPreprocessModelData(request, context, flow, opId);
            addDataField(context, GENEConstance.SERVLET_REQUEST, request);
            String retValue = flow.execute(context, opId);
            if (transactionManager != null) {
                transactionManager.commit();
            }
            result.result = retValue;
        } catch (Exception e) {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.ERROR, 0, "Failed to execute flow ".concat(String.valueOf(bizId)), e);
            result.e = e;
            if (transactionManager != null) {
                transactionManager.rollback();
            }
        }
        return result;
    }

    protected void initServerAddress(HttpServletRequest request) throws Exception {
        if (!isServerAddressInitialized) {
            try {
                LifeLogonManager.setServerAddress(String.valueOf(InetAddress.getLocalHost().getHostAddress()) + ":" + request.getLocalPort());
            } catch (Exception unused) {
                Trace.logWarning("LifeCore", "Initialize runtime server address error, so keeps [settings.xml#LifeSettings.serverAddress]'s init value");
            }
            isServerAddressInitialized = true;
        }
    }

    protected Session initSession(HttpServletRequest request, HttpServletResponse response) throws Exception {
        if (this.sessionManager == null) {
            Trace.logError("LifeSession", "Session manager not set for the GENE component factory! please set it in GENEServletContext.xml");
            throw new GENEException("Session manager not set for the GENE component factory! please set it in GENEServletContext.xml");
        }
        Session session = this.sessionManager.getSession(request, response, true);
        Context sessionContext = this.geneFactory.getContext((Document) null, this.sessionContextName);
        try {
            sessionContext.setDataValue(this.sessionIdFieldName, session.getId());
        } catch (Exception e) {
            Trace.logWarning("LifeSession", "Session controller: Data field [" + this.sessionIdFieldName + "] not found in session context! ", e);
        }
        session.setAttribute(GENEConstance.ATTR_CONTEXT, sessionContext);
        return session;
    }

    private void setLanguage(HttpServletRequest request, Context sessionContext) throws TranFailException {
        if (sessionContext == null) {
            return;
        }
        try {
            String parameter = request.getParameter("language");
            String language = parameter;
            if (StringUtils.isBlank(parameter)) {
                Cookie[] cookies = request.getCookies();
                int i = 0;
                while (true) {
                    if (i >= cookies.length) {
                        break;
                    }
                    String cookieName = cookies[i].getName();
                    if (!"language".equals(cookieName)) {
                        i++;
                    } else {
                        language = cookies[i].getValue();
                        break;
                    }
                }
            }
            StringUtils.isBlank(language);
            sessionContext.setDataValue("session_language", LifeClientRequest.getClientIP(request));
        } catch (Exception ex) {
            Trace.logError("LifeSession", "用户登录语种获取出错", ex);
            throw new TranFailException("用户登录语种获取出错", ex);
        }
    }

    protected void singleLogonCheck(String lastSessionId) throws TranFailException {
        LifeCacheLogonManager.checkUserSingleLogon(lastSessionId, this.sessionManager);
    }

    protected void singleLogonCheck(Context context) throws TranFailException {
        String sessionId = null;
        try {
            sessionId = (String) context.getDataValue(TEntity.appKeyFieldname);
        } catch (GENEException ex) {
            Trace.logWarning("LifeSession", ex.getMessage(), ex);
        }
        LifeLogonManager.addUser(context, sessionId, this.sessionManager);
    }

    public ModelAndView handleException(HttpServletRequest request, HttpServletResponse response, Exception e) {
        Context tmpCtx;
        try {
            GENESession session = (GENESession) request.getAttribute(GENEConstance.ATTR_SESSION);
            if (session != null) {
                this.sessionManager.removeSession(session);
                if (session != null && (tmpCtx = (Context) session.getAttribute(GENEConstance.ATTR_CONTEXT)) != null) {
                    if (e instanceof GENEException) {
                        String errorCode = ((GENEException) e).getErrorCode();
                        if (LifeStandard.getBankSettingsValue("monitorException").indexOf(errorCode) >= 0) {
                            tmpCtx.getDataValue("session_customerId");
                            if (tmpCtx.containsKey("session_userId")) {
                                tmpCtx.getDataValue("session_userId");
                            }
                        }
                    }
                    tmpCtx.terminate();
                }
            }
        } catch (Exception ee) {
            GENELog.log(GENEConstance.GENE_MVC, GENELog.WARNING, 0, "Session controller: terminat session context failure! ", ee);
        }
        Map model = new HashMap();
        model.put(GENEConstance.ATTR_EXCEPTION, e);
        return new ModelAndView(model, new MVCXmlView());
    }

    public Context putElementToContext(HttpServletRequest request, Context context, String sessionId) {
        String dataSourceName = null;
        String bankId = PlatformUtil.getBankId(request);
        try {
            bankId = LifePlatManager.getBankDBSource(bankId);
            dataSourceName = bankId;
        } catch (TranFailException e) {
            bankId.printStackTrace();
        }
        String clientIp = LifeClientRequest.getClientIP(request);
        context.put(TEntity.bankIdFieldName, bankId);
        context.put(TEntity.dataSourceName, dataSourceName);
        context.put(TEntity.sessionIdFieldName, sessionId);
        context.put(TEntity.appKeyFieldname, sessionId);
        context.put(TEntity.channelFieldname, TEntity.JRBChannel);
        context.put(TEntity.IS_LOGIN, TEntity.isSign_OK);
        context.put(TEntity.CLIENTIP, clientIp);
        String uri = request.getRequestURI();
        String method = request.getMethod();
        String format = request.getParameter(TEntity.responseFormat);
        context.put(TEntity.uriFieldname, uri);
        context.put(TEntity.responseFormat, format);
        context.put(TEntity.requestMethod, method);
        return context;
    }

    protected void setSessionTimeout(Session session, Context sessionContext) {
    }

    public String getSessionContextName() {
        return this.sessionContextName;
    }

    public void setSessionContextName(String sessionContextName) {
        this.sessionContextName = sessionContextName;
    }

    public void setSessionIdFieldName(String sessionIdFieldName) {
        this.sessionIdFieldName = sessionIdFieldName;
    }

    public void setIsSingleLogonCheck(boolean isSingleLogonCheck) {
        this.isSingleLogonCheck = isSingleLogonCheck;
    }
}
